class pintarTweet {

  float leading_txt = 0;
  float alturaD;
  float alturaA;
  float altura; 
  float font_size;
  float height_texto;
  float hText;
  float num_size;
  float width_texto;
  int tweet_index;
  int num_rts;
  String text_tweet;
  int m = 0;
  String fecha_tw;
  String hora_tw;
  float posX_img;
  float posY_img;
  Tweets drawTweets;

  PImage a;
  PImage b;
  PImage user;



  public pintarTweet(Tweets t) {
    drawTweets = t;

    a = loadImage("acampadabcn.jpeg");
    b = loadImage("toma_la_calle2.jpeg");
  }




  public void pintaTextMes(Tweet t) {

    posX_img = t.getPosXMes()+(t.getTamanyImg()/2)+10;
    posY_img = t.getPosYMes()+(t.getTamanyImg()/2)+5;
    text_tweet = t.getText();
    fecha_tw = t.getData();
    hora_tw = t.getHora();


    font_size = 18;

    textFont(font, font_size);

    //Calcula l'interliniat, l'amplada i l'altura que tindrà el tweet
    leading_txt = 21;
    hText = calculateTextHeight(text_tweet, width_texto, font_size, leading_txt);

    width_texto = 300;

    if ((posX_img + width_texto) >= width-30) {
      posX_img = (posX_img-t.getTamanyImg()) - width_texto -30;
    }

    if ((posY_img + (hText+30)) >= height-20) {
      posY_img = (posY_img-t.getTamanyImg()) - hText-30;
    }


    stroke(#d1d1d1);
    fill(#efefef, 240);

    rect(posX_img-10, posY_img-5, width_texto+30, hText+30);

    textAlign(LEFT, TOP);
    fill(#555555); 
    textLeading(leading_txt);

    text(text_tweet, posX_img, posY_img, width_texto, hText);

    pintaData();
  }


  public void pintaTextDia(Tweet t) {

    posX_img = t.getPosXDia()+(t.getTamanyImg()/2)+10;
    posY_img = t.getPosYDia()+(t.getTamanyImg()/2)+5;
    text_tweet = t.getText();
    fecha_tw = t.getData();
    hora_tw = t.getHora();

    font_size = 18;

    textFont(font, font_size);

    //Calcula l'interliniat, l'amplada i l'altura que tindrà el tweet
    leading_txt = 21;
    hText = calculateTextHeight(text_tweet, width_texto, font_size, leading_txt);

    width_texto = 300;

    if ((posX_img + width_texto) >= width-30) {
      posX_img = (posX_img-t.getTamanyImg()) - width_texto -30;
    }

    if ((posY_img + (hText+30)) >= height-20) {
      posY_img = (posY_img-t.getTamanyImg()) - hText-30;
    }


    stroke(#d1d1d1);
    fill(#f3f3f3, 240);
    rect(posX_img-10, posY_img-5, width_texto+30, hText+30);
    textAlign(LEFT, TOP);
    fill(#555555); 
    textLeading(leading_txt);
    text(text_tweet, posX_img, posY_img, width_texto, hText);

    pintaData();
  }



  private float calculateTextHeight(String text_tweet, float width_texto, float font_size, float leading_txt) {
    String[] wordsArray;
    String tempString = "";
    int numLines = 0;

    wordsArray = split(text_tweet, " ");

    for (int i= 0; i < wordsArray.length; i++) {
      if (textWidth(tempString + wordsArray[i]) < 300) {
        tempString += wordsArray[i] + " ";
      }
      else {
        tempString = wordsArray [i] + " ";
        numLines++;
      }
    }
    numLines++;

    height_texto = numLines * (textDescent() + textAscent());

    println("num linias -----> "+numLines);
    println("height_texto --->" + height_texto);


    return (height_texto);
  }

  public void pintaData() {
    noStroke();
    fill(#fcfcfc, 240);
    rect(posX_img-9, posY_img + hText-4, 329, 29);
    textAlign (LEFT, TOP);
    fill(150);
    textFont(font, 14);
    text(fecha_tw + "    " + hora_tw, posX_img, posY_img + hText, 150, 20);
  }


  public void pintaImgsMes() {


    for (int i=0; i<drawTweets.getNumTweets(); i++) {
      Tweet tw = drawTweets.getTweet(i);
      String textTw = tw.getText();
      String[] wordsTweet;


      float tamany = tw.getTamanyImg();

      wordsTweet = split(textTw, " ");

      for (int j= 0; j < wordsTweet.length; j++) {



        String acampadabcn = "#acampadabcn";
        String tomalacalle = "#tomalacalle"; 

        if (wordsTweet[j].equals(acampadabcn)) {
          imageMode(CENTER);
          tint(240, 170);
          image(a, tw.getPosXMes(), tw.getPosYMes(), tamany, tamany);

          break;
        }
        else if (wordsTweet[j].equals(tomalacalle)) {
          imageMode(CENTER);
          tint(240, 170);
          image(b, tw.getPosXMes(), tw.getPosYMes(), tamany, tamany);

          break;
        }
        else {
        }
      }
    }
  }

  public void pintaImgsDia() {


    for (int i=0; i<drawTweets.getNumTweets(); i++) {
      Tweet tw = drawTweets.getTweet(i);
      String textTw = tw.getText();
      String[] wordsArray;


      float tamany = tw.getTamanyImg();

      wordsArray = split(textTw, " ");

      for (int j= 0; j < wordsArray.length; j++) {


        String acampadabcn = "#acampadabcn";
        String tomalacalle = "#tomalacalle"; 

        if (wordsArray[j].equals(acampadabcn)) {
          imageMode(CENTER);
          tint(240, 170);
          image(a, tw.getPosXDia(), tw.getPosYDia(), tamany, tamany);

          break;
        }
        else if (wordsArray[j].equals(tomalacalle)) {
          imageMode(CENTER);
          tint(240, 170);
          image(b, tw.getPosXDia(), tw.getPosYDia(), tamany, tamany);

          break;
        }
        else {
        }
      }
    }
  }


  public void pintaImgMes(Tweet t) {
    user = loadImage(t.getIdUser(), "jpeg");
    float tamany = t.getTamanyImg();
    imageMode(CENTER);
    image(user, t.getPosXMes(), t.getPosYMes(), tamany, tamany);
  }

  public void pintaImgDia(Tweet t) {
    user = loadImage(t.getIdUser(), "jpeg");
    float tamany = t.getTamanyImg();
    imageMode(CENTER);
    image(user, t.getPosXDia(), t.getPosYDia(), tamany, tamany);
  }
}

